题目
给任意一个字符串,求最少插入多少字符可以得到回文串。
题解
参照leetcode 1312。
求该字符串与它的反序的最长公共子序列(LCS)长度,然后用字符串长度减去这个长度,输出答案完事,时间复杂度为字符串长度的平方。签到题。
代码
因为一发入魂,就没写测试例生成和暴力验证。
AC代码
1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50
|
#include <algorithm> #include <cmath> #include <cstdio> #include <ctime> #include <cstring> #include <iostream> #include <queue> #include <map> #include <set> #include <string> #include <list> #include <forward_list> #include <stack> #include <unordered_set> #include <vector> #include <limits.h>
#define DISPLAY_A 0
using namespace std;
const int MAX = 5e3 + 7;
int main() { std::ios::sync_with_stdio(false); std::cin.tie(0); int n; cin >> n; string s; cin >> s; string inv = s; reverse(inv.begin(), inv.end()); vector<vector<int>> dp(n + 1, vector<int>(n + 1)); dp[0][0] = 0; for (int i = 1; i <= n; i++) { for (int j = 1; j <= n; j++) { if (s[i - 1] == inv[j - 1]) { dp[i][j] = dp[i - 1][j - 1] + 1; } else { dp[i][j] = max(dp[i][j - 1], dp[i - 1][j]); } } } cout << n - dp[n][n] << endl; return 0; }
|